-- count=0, condition=turn5, Actions=NewRoundAction
function Wave(action)
	player = 0

	-- *** Spawn zone ***
	-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes.
	-- If the script runs out of hexes, the remainder of the units will not be spawned.
	zone = { {7,12},{7,13},{8,14},{8,15},{6,13},{8,16},{7,14},{7,15},{7,17},{9,16},{7,18} }

	-- *** wave ***
	-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }
	-- If no organic transport is needed, its respective field should be empty string ("").
	units = { {"SUMntInf", "", 1, 0}, {"Regular", "SUTruck", 0, 0}, {"122mmM1938", "SUTruck", 0, 0}, {"Regular", "SUTruck", 0, 0}, {"KV1-40", "", 0, 0}, {"SUCavalry", "", 1, 0} }

	SpawnWave(player, zone, units)
end


function turn5()
	return world.round == 6	-- Runde 5 definieren
end


-- Hilfsfunktion
function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)
	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = true
		create_action.cost = 0
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
	end

	MessageBox("Endlich!", "Unsere Verstärkung ist eingetroffen.")
end
